OpenTTD Source: MockFontCache Class Reference

OpenTTD Source 15.0-beta1

Public Member Functions | Static Public Member Functions
MockFontCache Class Reference

Font cache for mocking basic use of fonts. More...

`#include <mock_fontcache.h>`

Inheritance diagram for MockFontCache:

## Public Member Functions
| MockFontCache (FontSize fs)
void | SetUnicodeGlyph (char32_t, SpriteID) override
| Map a SpriteID to the key.
void | InitializeUnicodeGlyphMap () override
| Initialize the glyph map.
void | ClearFontCache () override
| Clear the font cache.
const Sprite * | GetGlyph (GlyphID) override
| Get the glyph (sprite) of the given key.
uint | GetGlyphWidth (GlyphID) override
| Get the width of the glyph with the given key.
bool | GetDrawGlyphShadow () override
| Do we need to draw a glyph shadow?
GlyphID | MapCharToGlyph (char32_t key, bool allow_fallback=true) override
| Map a character into a glyph.
std::string | GetFontName () override
| Get the name of this font.
bool | IsBuiltInFont () override
| Is this a built-in sprite font?
Public Member Functions inherited from FontCache
| FontCache (FontSize fs)
| Create a new font cache.
virtual | ~FontCache ()
| Clean everything up.
FontSize | GetSize () const
| Get the FontSize of the font.
int | GetHeight () const
| Get the height of the font.
int | GetAscender () const
| Get the ascender value of the font.
int | GetDescender () const
| Get the descender value of the font.
virtual int | GetFontSize () const
| Get the nominal font size of the font.
virtual const void * | GetOSHandle ()
| Get the native OS font handle, if there is one.
bool | HasParent ()
| Check whether the font cache has a parent.

## Static Public Member Functions
static void | InitializeFontCaches ()
Static Public Member Functions inherited from FontCache
static void | InitializeFontCaches ()
static int | GetDefaultFontHeight (FontSize fs)
static FontCache * | Get (FontSize fs)
| Get the font cache of a given font size.
static std::string | GetName (FontSize fs)
| Get the font name of a given font size.

## Additional Inherited Members
Protected Attributes inherited from FontCache
FontCache * | parent
| The parent of this font cache.
const FontSize | fs
| The size of the font.
int | height
| The height of the font.
int | ascender
| The ascender value of the font.
int | descender
| The descender value of the font.
Static Protected Attributes inherited from FontCache
static FontCache * | caches [FS_END]
| All the font caches.

## Detailed Description

Font cache for mocking basic use of fonts.

Definition at line 19 of file mock_fontcache.h.

## Constructor & Destructor Documentation

## ◆ MockFontCache()

MockFontCache::MockFontCache | ( | FontSize | fs | ) |
| inline

Definition at line 21 of file mock_fontcache.h.

## Member Function Documentation

## ◆ ClearFontCache()

void MockFontCache::ClearFontCache | ( |  | ) |
| inlineoverridevirtual

Clear the font cache.

Implements FontCache.

Definition at line 28 of file mock_fontcache.h.

## ◆ GetDrawGlyphShadow()

bool MockFontCache::GetDrawGlyphShadow | ( |  | ) |
| inlineoverridevirtual

Do we need to draw a glyph shadow?

Returns
  True if it has to be done, otherwise false.

Implements FontCache.

Definition at line 31 of file mock_fontcache.h.

## ◆ GetFontName()

std::string MockFontCache::GetFontName | ( |  | ) |
| inlineoverridevirtual

Get the name of this font.

Returns
  The name of the font.

Implements FontCache.

Definition at line 33 of file mock_fontcache.h.

## ◆ GetGlyph()

const Sprite * MockFontCache::GetGlyph | ( | GlyphID | key | ) |
| inlineoverridevirtual

Get the glyph (sprite) of the given key.

Parameters

  key | The key to look up.

Returns
  The sprite.

Implements FontCache.

Definition at line 29 of file mock_fontcache.h.

## ◆ GetGlyphWidth()

uint MockFontCache::GetGlyphWidth | ( | GlyphID | key | ) |
| inlineoverridevirtual

Get the width of the glyph with the given key.

Parameters

  key | The key to look up.

Returns
  The width.

Implements FontCache.

Definition at line 30 of file mock_fontcache.h.

References FontCache::height.

## ◆ InitializeFontCaches()

static void MockFontCache::InitializeFontCaches | ( |  | ) |
| inlinestatic

Definition at line 36 of file mock_fontcache.h.

## ◆ InitializeUnicodeGlyphMap()

void MockFontCache::InitializeUnicodeGlyphMap | ( |  | ) |
| inlineoverridevirtual

Initialize the glyph map.

Implements FontCache.

Definition at line 27 of file mock_fontcache.h.

## ◆ IsBuiltInFont()

bool MockFontCache::IsBuiltInFont | ( |  | ) |
| inlineoverridevirtual

Is this a built-in sprite font?

Implements FontCache.

Definition at line 34 of file mock_fontcache.h.

## ◆ MapCharToGlyph()

GlyphID MockFontCache::MapCharToGlyph | ( | char32_t | key,
|  | bool | fallback = `true`
| ) |  |
| inlineoverridevirtual

Map a character into a glyph.

Parameters

  key | The character.
  fallback | Allow fallback to the parent font.

Returns
  The glyph ID used to draw the character.

Implements FontCache.

Definition at line 32 of file mock_fontcache.h.

## ◆ SetUnicodeGlyph()

void MockFontCache::SetUnicodeGlyph | ( | char32_t | key,
|  | SpriteID | sprite
| ) |  |
| inlineoverridevirtual

Map a SpriteID to the key.

Parameters

  key | The key to map to.
  sprite | The sprite that is being mapped.

Implements FontCache.

Definition at line 26 of file mock_fontcache.h.

The documentation for this class was generated from the following file:

- src/tests/mock_fontcache.h